def expect_response(message_type):
    if message_type in NO_RESPONSE:
        return False
    return True

HANDSHAKE = b'HS'
CONNECT = b'CN'
DISCONNECT = b'DC'
PREPARE = b'PP'
DIRECT_UPDATE = b'DU'
DIRECT_QUERY = b'DQ'
DIRECT_STORED_PROCEDURE = b'DS'
PREPARE_DIALECT = b'PD'
DIRECT_EXECUTE_DIALECT = b'DD'
PREPARED_UPDATE_EXECUTE = b'PU'
PREPARED_QUERY_EXECUTE = b'PQ'
FETCH_DATA = b'FD'
CLOSE_CURSOR = b'CC'
PREPARE_STORED_PROCEDURE = b'SP'
STORED_PROCEDURE_UPDATE_EXECUTE = b'SU'
STORED_PROCEDURE_QUERY_EXECUTE = b'SQ'
STORED_PROCEDURE_FETCH_DATA = b'SF'
EXECUTE_MULTIPLE_RESULT_SETS = b'MS'
MULTIPLE_RESULT_SETS_FETCH_DATA = b'MD'
GET_MORE_RESULTS = b'MR'
GET_STREAM_SIZE = b'SS'
RETRIEVE_STREAM = b'RS'
OPEN_STREAM = b'OS'
READ_STREAM = b'JS'
READ_STREAM_ODBC = b'AS'
STORE_BINARY_STREAM = b'SB'
STORE_CHARACTER_STREAM = b'SM'
STREAM_GET_BYTES  = b'GB'
STREAM_SET_BYTES  = b'SZ'
STREAM_TRUNCATE  = b'SX'
STREAM_GET_POSITION   = b'GP'
CLOSE_STREAM   = b'CS'
GET_RESULT_SET_OBJECT = b'FR'
GET_STRUCT_OBJECT = b'FS'
COMMIT = b'TC'
ROLLBACK = b'TR'
READ_COMMITTED = b'RC'
READ_UNCOMMITTED = b'RU'
ISOLATION_LEVEL = b'IL'
AUTOCOMMIT_OFF = b'AF'
AUTOCOMMIT_ON = b'AN'
TOGGLE_SYNCHRONOUS_COMMIT = b'TS'
GET_AUTO_GENERATED_KEYS = b'GG'
IN_TRANSACTION = b'IT'
JDBC_BESTROWID = b'BR'
JDBC_CATALOGS = b'CA'
JDBC_COLUMNPRIV = b'CP'
JDBC_COLUMNS = b'CO'
JDBC_CROSSREFERENCE = b'CR'
JDBC_EXPORTEDKEYS = b'EK'
JDBC_IMPORTEDKEYS = b'IK'
JDBC_INDEXINFO = b'II'
JDBC_PRIMARYKEYS = b'PK'
JDBC_PROCEDURECOL = b'PC'
JDBC_PROCEDURES = b'PR'
JDBC_SCHEMAS = b'SC'
JDBC_TABLEPRIV = b'TP'
JDBC_TABLES = b'TA'
JDBC_TABLETYPES = b'TT'
JDBC_TYPEINFO = b'TI'
JDBC_VERSIONCOL = b'VC'
ODBC_BESTROWID = b'br'
ODBC_CATALOGS = b'ca'
ODBC_COLUMNPRIV = b'cp'
ODBC_COLUMNS_35 = b'c3'
ODBC_CROSSREFERENCE_35 = b'r3'
ODBC_EXPORTEDKEYS_35 = b'e3'
ODBC_IMPORTEDKEYS_35 = b'i3'
ODBC_PROCEDURECOL_35 = b'p3'
ODBC_TYPEINFO_35 = b't3'
ODBC_COLUMNS = b'co'
ODBC_CROSSREFERENCE = b'cr'
ODBC_EXPORTEDKEYS = b'ek'
ODBC_IMPORTEDKEYS = b'ik'
ODBC_INDEXINFO = b'ii'
ODBC_PRIMARYKEYS = b'pk'
ODBC_PROCEDURECOL = b'pc'
ODBC_PROCEDURES = b'pr'
ODBC_SCHEMAS = b'sc'
ODBC_STATISTICS = b'st'
ODBC_TABLEPRIV = b'tp'
ODBC_TABLES = b'ta'
ODBC_TABLETYPES = b'tt'
ODBC_TYPEINFO = b'ti'
ODBC_VERSIONCOL = b'vc'
JDBC_UDTS = b'UT'
JDBC_SUPER_TYPES = b'SY'
JDBC_SUPER_TABLES = b'SL'
JDBC_GET_ATTRIBUTES = b'AT'
JDBC_GET_FUNCTION_COLUMNS  = b'FC'
JDBC_GET_FUNCTIONS  = b'FN'
JDBC_CLIENT_INFO_PROPERTIES  = b'CF'
SET_CLIENT_INFO_PROPERTIES   = b'CG'
XA_START = b'XS'
XA_END = b'XE'
XA_FORGET = b'XF'
XA_PREPARE = b'XP'
XA_COMMIT = b'XC'
XA_ROLLBACK = b'XR'
XA_RECOVER = b'XV'
EXECUTE_STATIC_CURSOR = b'EX'
DIRECT_STATIC_CURSOR = b'DX'
FETCH_STATIC_CURSOR = b'FX'
UPDATE_CACHE = b'UC'
RESET_CONNECTION = b'RN'
GET_SERVER_ERROR = b'OE'
EXECUTE_STATEMENT_BATCH = b'EB'
CLOSE_STATEMENT = b'CU'
QUICK_LOAD = b'QL'
QUICK_CHILD_TABLE_LOAD = b'QZ'
QUICK_CHILD_TABLE_CREATE = b'QX'
QUICK_CHILD_TABLE_REMOVE = b'QK'
QUICK_STORE = b'QS'
QUICK_CREATE = b'QC'
QUICK_REMOVE = b'QR'
QUICK_FIND_ROWID_BY_PK = b'Q1'
QUICK_FIND_ROWID_BY_CONSTRAINT = b'Q2'
QUICK_FIND_PK_BY_CONSTRAINT = b'Q3'
QUICK_REMOVE_BY_PK = b'Q4'
QUICK_CREATE_BY_PK = b'Q5'
QUICK_STORE_BY_PK = b'Q6'
QUICK_LOAD_BY_PK = b'Q7'
QUICK_CHILD_TABLE_REMOVE_BY_PK = b'Q8'
QUICK_CHILD_TABLE_CREATE_BY_PK = b'Q9'
QUICK_CHILD_TABLE_LOAD_BY_PK = b'QA'
QUICK_GET_CHILDREN_PKS = b'QB'
QUICK_GET_CHILDREN_PKS_BY_PK = b'QD'
QUICK_FIND_PK_BY_ROWID = b'QE'
QUICK_BULK_LOAD = b'QM'
QUICK_BULK_CREATE = b'QN'
QUICK_BULK_STORE = b'QO'
QUICK_BULK_SAVE_BY_PK  = b'QW'
QUICK_QUERY  = b'QQ'
QUICK_JPA_FLUSH  = b'QF'
GET_CACHE_INFO = b'CI'
PING = b'PG'
PING_TWO = b'P2'
IS_TWO_FACTOR_ENABLED = b'2E'
SEND_TWO_FACTOR_TOKEN = b'2F'
STREAM_SET_PREFETCH_SIZE = b'SN'
EXTERNAL_INTERUPT = b'EI'
GET_NAMESPACES_MSG = b'CI'
GATEWAY_INIT = b'GI'

NO_RESPONSE = [AUTOCOMMIT_OFF,
               AUTOCOMMIT_ON,
               READ_COMMITTED,
               READ_UNCOMMITTED,
               CLOSE_CURSOR,
               CLOSE_STREAM,
               CLOSE_STATEMENT,
               RESET_CONNECTION,
               DISCONNECT]